VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4350
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7560
   LinkTopic       =   "Form1"
   ScaleHeight     =   4350
   ScaleWidth      =   7560
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4095
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   1  'Horizontal
      TabIndex        =   0
      Top             =   120
      Width           =   7335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Activate()

  'DECLARATION OF VARIABLES
  '========================

  'This string will hold all the timetables in 'columns'
  'We will write this string later to the multiline textbox in one go
  Dim sText As String
  
  'This string will hold 1 product string.
  'It is used to create sText
  Dim sProduct As String
  
  'Declare out other needed numbers
  'Do NOT do:
  '  Dim TimesTable, Number as integer
  'This will NOT declare TimesTable as an integer, but as a variant.
  'Always seperate your declare statements to avoid such errors.
  Dim Number As Integer
  Dim TimesTable As Integer
  
  
  'MAIN ROUTINE TO CREATE THE RESULT
  '=================================
  
  'Make sure our total string is empty to start with
  sText = ""
  
  'To get this output:
  '  1 x 1 = 1     1 x 2 = 2     1 x 3 = 3     ...     1 x 12 = 12
  '  2 x 1 = 2     2 x 2 = 4     2 x 3 = 6     ...     2 x 12 = 24
  '  ...           ...           ...           ...     ...
  '  12 x 1 = 12   12 x 2 = 24   12 x 3 = 36   ...     12 x 12 = 244
  'We need to create each line one by one. This means the inner loop
  'needs to be the "TimesTable" instead of the "Number".
  '
  'Also, to align the columns properly, we need to add an x amoung of
  'spaces after each "N x T = R" depending on how long the "N x T = R" is.
  'This is done with the use of "sProduct"
  
  For Number = 1 To 12
    For TimesTable = 1 To 12
      sProduct = Number & " x " & TimesTable & " = " & (Number * TimesTable)
      
      'Longest possible sProduct would be "12 x 12 = 244" in this case.
      'Meaning a string length of 13 characters. After this maximum length
      'we add another 3 spaces for a nice gap between the columns.
      'Note that the following line can be done in many ways (one of which
      'the use of the Format() function. But for now, we're simply going
      'to add the needed spaces with a small 'trick':
      
      sProduct = Left$(sProduct + Space$(7), 16)
      'Note the 7. We get to this number like this:
      '  (maximumlength + 3 extra spaces) - minimumlength
      '  (totallength) - minimumlength
      '  (13 + 3) - 9
      'So there is realy no need to add more then 7 spaces since 1 product
      'string is never going to be shorter then 9 characters and 9 + 7 = 16,
      'being our maximumlength of 1 product string ("12 x 12 = 244") plus the
      'three added spaces.
      
      'Now add sProduct to create 1 full row of products:
      sText = sText & sProduct
      
    Next TimesTable
    
    '1 line of products is now created, so we need to add the
    'final Newline character(s) to statr a new line.
    sText = sText & vbCrLf
    
  Next Number
  
  
  'ROUTINE TO ADD THE RESULT TO THE TEXTBOX
  '========================================
  
  'Our total textstring is created so add it to the textbox
  
  'Make sure some properties of the textbox are set correctly.
  'This includes:
  '  * The textbox must be 'MultiLine'
  '  * The horizontal scrollbar must be enabled
  '  * The font should be a proportional font like 'Courier New'
  'Expirement with these (especially the font) to see how it effects the
  'final output...
  
  Text1.Text = sText
  
End Sub
